package com.hp.javaci;


import java.io.IOException;

class ShutdownHook {
  private static String clasS = "ShutdownHook";

  ShutdownHook() {
    //System.out.println("ShutdownHook()");

    //we need the security manager so we can save the status that was passed
    //in System.exit(stat);

    try {
      System.setSecurityManager(new JCISecurityManager());

    } catch(SecurityException e) {
      System.out.println("ShutdownHook.setSecurityManager threw " + e);
    }


    Runtime.getRuntime().addShutdownHook(new Thread() {

      private void cicmd(String s) {
	try {
	  //System.out.println("ShutdownHook.cicmd("+s+")");

	  Process p = Runtime.getRuntime().exec(new String[] {"/SYS/PUB/CI"
	   ,s
	  });

	/*int status; //our waitFor() method doesn't block at all right now
	  try {
	    status = p.waitFor();
	    //System.out.println("status="+status);

	  } catch(InterruptedException e) {
	    System.out.println("ShutdownHook."+e);
	  }*/

	} catch(IOException e) {
	  System.out.println("ShutdownHook."+e);
	}
      }

      public void run() {
        //Put any global shutdown behavior here. We don't actually let the JVM
        //shutdown via the JCISecurityManager overriding checkExit().

        String where = clasS + ".run";
	//System.out.println(where);

	int status = JCIRuntime.getStatus();
	System.out.println(where + ".exit status=" + status);

        cicmd("setvar hpresult " + status);
        cicmd("#waitFor() doesn't really wait");//waste some time with this

	System.out.println("ShutdownHook.run().return");
      }
    });
  }
}
