package com.hp.javaci;


import java.io.IOException;

class SystemExit {
  private static String clasS = "SystemExit";

  SystemExit() {}

  static {
    String where = clasS + ".static {}";
    //System.out.println(where);

    //we need the security manager so we can save the status that was passed
    //in System.exit(stat);

    try {
      System.setSecurityManager(new JCISecurityManager());

    } catch(SecurityException e) {
      System.out.println(where + ".setSecurityManager threw " + e);
    }
  }


  static void run() {
    //Put any global shutdown behavior here. We don't actually let the JVM
    //shutdown via the JCISecurityManager overriding checkExit().

    //String where = clasS + ".run";
    //System.out.println(where);

    int status = JCIRuntime.getStatus();
    //System.out.println(where + ".exit status=" + status);

    CI.getCI().doCICommand("setvar JAVACI_EXIT_STATUS " + status);

    //System.out.println("SystemExit.run().return");
  }
}
